"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactFontAwesome = require("react-font-awesome-5");

var _reactBootstrap = require("react-bootstrap");

var _atpPointfree = require("atp-pointfree");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
    var onChange = _ref.onChange,
        onKeyDown = _ref.onKeyDown,
        allTags = _ref.allTags,
        tag = _ref.tag,
        selectedTagIndex = _ref.selectedTagIndex,
        selectedTag = _ref.selectedTag,
        hideTagEditor = _ref.hideTagEditor,
        isEditing = _ref.isEditing,
        showTagEditor = _ref.showTagEditor,
        children = _ref.children,
        onSelectTag = _ref.onSelectTag;
    return isEditing ? _react2.default.createElement(
        "span",
        { style: { position: "relative" } },
        _react2.default.createElement("input", { autoFocus: true, onChange: onChange, onKeyDown: onKeyDown(selectedTag, allTags.length) }),
        "\xA0",
        _react2.default.createElement(
            "div",
            { style: { position: "absolute", top: "calc(100% + 5px)", left: "0" } },
            _react2.default.createElement(
                _reactBootstrap.ListGroup,
                null,
                allTags.map(function (tag, index) {
                    return _react2.default.createElement(
                        _reactBootstrap.ListGroupItem,
                        {
                            key: tag.id,
                            onClick: onSelectTag(tag.tag),
                            style: {
                                width: "100%"
                            },
                            className: index + 1 === selectedTagIndex ? "active" : ""
                        },
                        tag.tag
                    );
                })
            )
        ),
        _react2.default.createElement(
            "span",
            { className: "text-danger" },
            _react2.default.createElement(_reactFontAwesome.Icon.Times, { onClick: hideTagEditor })
        )
    ) : _react2.default.createElement(
        _reactBootstrap.Button,
        { bsStyle: "link", onClick: showTagEditor },
        _react2.default.Children.map(children, _atpPointfree.identity)
    );
};