'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _reactFontAwesome = require('react-font-awesome-5');

var _atpUac = require('atp-uac');

var _selector = require('../containers/selector');

var _selector2 = _interopRequireDefault(_selector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
    var entityTags = _ref.entityTags,
        selectorId = _ref.selectorId,
        onDeleteTag = _ref.onDeleteTag,
        onAddTag = _ref.onAddTag;
    return _react2.default.createElement(
        _reactBootstrap.Panel,
        null,
        _react2.default.createElement(
            _reactBootstrap.Panel.Heading,
            null,
            _react2.default.createElement(_reactFontAwesome.Icon.Tags, null),
            ' Tags'
        ),
        _react2.default.createElement(
            _reactBootstrap.Panel.Body,
            null,
            entityTags.map(function (tag) {
                return _react2.default.createElement(
                    _reactBootstrap.Badge,
                    { key: tag.id, style: { marginRight: "8px" } },
                    tag && _react2.default.createElement(
                        'span',
                        null,
                        tag.tag,
                        '\xA0',
                        _react2.default.createElement(_reactFontAwesome.Icon.Times, { onClick: onDeleteTag(tag.id) })
                    )
                );
            }),
            _react2.default.createElement(
                _atpUac.HasPermission,
                { permissions: ["tag.tag.create"] },
                _react2.default.createElement(
                    _selector2.default,
                    { id: selectorId, onAdd: onAddTag },
                    _react2.default.createElement(_reactFontAwesome.Icon.Plus, null),
                    ' Add tags'
                )
            )
        )
    );
};