"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _reactLifecycleComponent = require("react-lifecycle-component");

var _selector = require("../components/selector");

var _selector2 = _interopRequireDefault(_selector);

var _tag = require("../reducer/tag");

var _atpPointfree = require("atp-pointfree");

var _basicReducers = require("basic-reducers");

var _keycode = require("keycode");

var _keycode2 = _interopRequireDefault(_keycode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toggleId = function toggleId(id) {
    return "tagEditor:" + id;
};
var tagsToShow = 10;

exports.default = (0, _reactLifecycleComponent.connectWithLifecycle)(function (state, _ref) {
    var id = _ref.id;

    var tag = _basicReducers.input.value((0, _atpPointfree.get)(state), toggleId(id)) || "";
    var allTags = (0, _tag.Tag)().select.all((0, _atpPointfree.get)(state)).filter(function (curTag) {
        return tag.length > 0 && curTag.tag.toLocaleLowerCase().indexOf(tag.toLocaleLowerCase()) !== -1;
    }).slice(0, tagsToShow);
    var selectedTagIndex = _basicReducers.counter.value((0, _atpPointfree.get)(state), toggleId(id));

    return {
        allTags: allTags,
        isEditing: _basicReducers.toggle.isVisible((0, _atpPointfree.get)(state), toggleId(id)),
        tag: _basicReducers.input.value((0, _atpPointfree.get)(state), toggleId(id)),
        selectedTagIndex: selectedTagIndex,
        selectedTag: selectedTagIndex > 0 && selectedTagIndex <= allTags.length ? allTags[selectedTagIndex - 1].tag : ""
    };
}, function (dispatch, _ref2) {
    var id = _ref2.id,
        onAdd = _ref2.onAdd,
        noCreate = _ref2.noCreate;
    return {
        componentDidMount: function componentDidMount() {},
        showTagEditor: function showTagEditor() {
            dispatch(_basicReducers.toggle.show(toggleId(id)));
            dispatch((0, _tag.Tag)().action.collection.get({}));
            dispatch(_basicReducers.input.clear(toggleId(id)));
            dispatch(_basicReducers.counter.reset(toggleId(id)));
        },
        hideTagEditor: function hideTagEditor() {
            dispatch(_basicReducers.toggle.hide(toggleId(id)));
        },
        onKeyDown: function onKeyDown(selectedTag, maxCount) {
            return function (e) {
                e.persist();
                setTimeout(function () {
                    var tag = selectedTag || e.target.value || "";
                    switch ((0, _keycode2.default)(e)) {
                        case 'esc':
                            dispatch(_basicReducers.toggle.hide(toggleId(id)));
                            break;
                        case 'enter':
                            if (selectedTag || !noCreate) {
                                dispatch(_basicReducers.input.clear(toggleId(id)));
                                dispatch(_basicReducers.toggle.hide(toggleId(id)));
                                dispatch(_basicReducers.counter.reset(toggleId(id)));
                                setTimeout(function () {
                                    dispatch(_basicReducers.toggle.show(toggleId(id)));
                                }, 0);
                                onAdd(tag);
                            }
                            break;
                        case 'down':
                            dispatch(_basicReducers.counter.increment(toggleId(id), maxCount));
                            break;
                        case 'up':
                            dispatch(_basicReducers.counter.decrement(toggleId(id), 0));
                            break;
                        default:
                            dispatch(_basicReducers.input.set(toggleId(id), tag));
                            break;
                    }
                }, 10);
            };
        },
        onSelectTag: function onSelectTag(tag) {
            return function () {
                dispatch(_basicReducers.input.clear(toggleId(id)));
                dispatch(_basicReducers.toggle.hide(toggleId(id)));
                dispatch(_basicReducers.counter.reset(toggleId(id)));
                setTimeout(function () {
                    dispatch(_basicReducers.toggle.show(toggleId(id)));
                }, 0);
                onAdd(tag);
            };
        }
    };
})(_selector2.default);