"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _reactLifecycleComponent = require("react-lifecycle-component");

var _tags = require("../components/tags");

var _tags2 = _interopRequireDefault(_tags);

var _tagEntity = require("../reducer/tag-entity");

var _atpPointfree = require("atp-pointfree");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _reactLifecycleComponent.connectWithLifecycle)(function (state, _ref) {
    var entityType = _ref.entityType,
        entityId = _ref.entityId;
    return {
        entityTags: (0, _tagEntity.TagEntity)().select.byList((0, _atpPointfree.get)(state), { entityType: entityType, entityId: entityId }),
        selectorId: entityType + ":" + entityId
    };
}, function (dispatch, _ref2) {
    var entityType = _ref2.entityType,
        entityId = _ref2.entityId;
    return {
        componentDidMount: function componentDidMount() {
            dispatch((0, _tagEntity.TagEntity)().action.collection.get({ entityType: entityType, entityId: entityId }));
        },
        componentWillReceiveProps: function componentWillReceiveProps(newProps) {
            if (newProps.entityType !== this.props.entityType || newProps.entityId !== this.props.entityId) {
                dispatch((0, _tagEntity.TagEntity)().action.collection.get({ entityType: newProps.entityType, entityId: newProps.entityId }));
            }
        },
        onAddTag: function onAddTag(tag) {
            dispatch((0, _tagEntity.TagEntity)().action.create({ entityType: entityType, entityId: entityId, tag: tag }, function () {
                dispatch((0, _tagEntity.TagEntity)().action.collection.get({ entityType: entityType, entityId: entityId }));
            }));
        },
        onDeleteTag: function onDeleteTag(id) {
            return function () {
                dispatch((0, _tagEntity.TagEntity)().action.delete(id, function () {
                    dispatch((0, _tagEntity.TagEntity)().action.collection.get({ entityType: entityType, entityId: entityId }));
                }));
            };
        }
    };
})(_tags2.default);